/****************************************************************************
 * @file     M0A23OC-PIN.c
 * @version  V1.29.0001
 * @Date     Wed Jul 03 2024 21:25:36 GMT+0800 (中国标准时间)
 * @brief    NuMicro generated code file
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright (C) 2013-2024 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/

/********************
MCU:M0A23OC1AC(SSOP20)
Pin Configuration:
Pin2:UART0_RXD
Pin3:UART0_TXD
Pin4:nRESET
Pin5:UART1_RXD
Pin6:PC.4
Pin7:UART1_TXD
Pin8:CAN0_RXD
Pin9:CAN0_TXD
Pin10:PWM0_CH0
Pin11:PB.6
Pin12:PB.5
Pin13:PB.4
Pin14:PC.2
Pin15:PC.1
Pin16:USCI0_CLK
Pin17:USCI0_DAT0
Pin18:ICE_CLK
Pin19:ICE_DAT
Module Configuration:
UART0_RXD(Pin:2)
UART0_TXD(Pin:3)
nRESET(Pin:4)
UART1_RXD(Pin:5)
UART1_TXD(Pin:7)
PC.1(Pin:15)
PC.2(Pin:14)
PC.4(Pin:6)
CAN0_RXD(Pin:8)
CAN0_TXD(Pin:9)
PWM0_CH0(Pin:10)
PB.4(Pin:13)
PB.5(Pin:12)
PB.6(Pin:11)
USCI0_CLK(Pin:16)
USCI0_DAT0(Pin:17)
ICE_CLK(Pin:18)
ICE_DAT(Pin:19)
GPIO Configuration:
PA.0:ICE_DAT(Pin:19)
PA.1:ICE_CLK(Pin:18)
PA.2:USCI0_DAT0(Pin:17)
PA.3:nRESET(Pin:4)
PA.4:UART0_TXD(Pin:3)
PA.5:UART0_RXD(Pin:2)
PB.4:PB.4(Pin:13)
PB.5:PB.5(Pin:12)
PB.6:PB.6(Pin:11)
PB.7:PWM0_CH0(Pin:10)
PC.0:USCI0_CLK(Pin:16)
PC.1:PC.1(Pin:15)
PC.2:PC.2(Pin:14)
PC.3:UART1_TXD(Pin:7)
PC.4:PC.4(Pin:6)
PC.5:UART1_RXD(Pin:5)
PC.6:CAN0_RXD(Pin:8)
PC.7:CAN0_TXD(Pin:9)
********************/

#include "M0A21.h"
void SYS_InitPin(void);
/*
 * @brief This function provides the configured MFP registers
 * @param None
 * @return None
 */
void SYS_InitPin(void)
{
    SYS->GPA_MFP0 = 0x020B0202UL;
    SYS->GPA_MFP1 = 0x00000908UL;
    SYS->GPB_MFP1 = 0x05000000UL;
    SYS->GPC_MFP0 = 0x1C00000AUL;
    SYS->GPC_MFP1 = 0x13141D00UL;

    return;
}

/*** (C) COPYRIGHT 2013-2024 Nuvoton Technology Corp. ***/
