/****************************************************************************
 * @file     M0A23OC.c
 * @version  V1.29.0001
 * @Date     Wed Jun 26 2024 21:53:54 GMT+0800 (中国标准时间)
 * @brief    NuMicro generated code file
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright (C) 2013-2024 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/

/********************
MCU:M0A23OC1AC(SSOP20)
Pin Configuration:
Pin2:UART0_RXD
Pin3:UART0_TXD
Pin4:nRESET
Pin5:UART1_RXD
Pin6:PC.4
Pin7:UART1_TXD
Pin8:CAN0_RXD
Pin9:CAN0_TXD
Pin10:PWM0_CH0
Pin11:PB.6
Pin12:PB.5
Pin13:PB.4
Pin14:PC.2
Pin15:PC.1
Pin16:USCI0_CLK
Pin17:USCI0_DAT0
Pin18:ICE_CLK
Pin19:ICE_DAT
Module Configuration:
UART0_RXD(Pin:2)
UART0_TXD(Pin:3)
nRESET(Pin:4)
UART1_RXD(Pin:5)
UART1_TXD(Pin:7)
PC.1(Pin:15)
PC.2(Pin:14)
PC.4(Pin:6)
CAN0_RXD(Pin:8)
CAN0_TXD(Pin:9)
PWM0_CH0(Pin:10)
PB.4(Pin:13)
PB.5(Pin:12)
PB.6(Pin:11)
USCI0_CLK(Pin:16)
USCI0_DAT0(Pin:17)
ICE_CLK(Pin:18)
ICE_DAT(Pin:19)
GPIO Configuration:
PA.0:ICE_DAT(Pin:19)
PA.1:ICE_CLK(Pin:18)
PA.2:USCI0_DAT0(Pin:17)
PA.3:nRESET(Pin:4)
PA.4:UART0_TXD(Pin:3)
PA.5:UART0_RXD(Pin:2)
PB.4:PB.4(Pin:13)
PB.5:PB.5(Pin:12)
PB.6:PB.6(Pin:11)
PB.7:PWM0_CH0(Pin:10)
PC.0:USCI0_CLK(Pin:16)
PC.1:PC.1(Pin:15)
PC.2:PC.2(Pin:14)
PC.3:UART1_TXD(Pin:7)
PC.4:PC.4(Pin:6)
PC.5:UART1_RXD(Pin:5)
PC.6:CAN0_RXD(Pin:8)
PC.7:CAN0_TXD(Pin:9)
********************/

#include "M0A21.h"

void M0A23OC_Pin_init_can0(void)
{
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC7MFP_Msk | SYS_GPC_MFP1_PC6MFP_Msk);
    SYS->GPC_MFP1 |= (SYS_GPC_MFP1_PC7MFP_CAN0_TXD | SYS_GPC_MFP1_PC6MFP_CAN0_RXD);

    return;
}

void M0A23OC_deinit_can0(void)
{
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC7MFP_Msk | SYS_GPC_MFP1_PC6MFP_Msk);

    return;
}

void M0A23OC_Pin_init_ice(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA1MFP_Msk | SYS_GPA_MFP0_PA0MFP_Msk);
    SYS->GPA_MFP0 |= (SYS_GPA_MFP0_PA1MFP_ICE_CLK | SYS_GPA_MFP0_PA0MFP_ICE_DAT);

    return;
}

void M0A23OC_deinit_ice(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA1MFP_Msk | SYS_GPA_MFP0_PA0MFP_Msk);

    return;
}

void M0A23OC_Pin_init_nreset(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA3MFP_Msk);
    SYS->GPA_MFP0 |= (SYS_GPA_MFP0_PA3MFP_nRESET);

    return;
}

void M0A23OC_deinit_nreset(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA3MFP_Msk);

    return;
}

void M0A23OC_Pin_init_pb(void)
{
    SYS->GPB_MFP1 &= ~(SYS_GPB_MFP1_PB6MFP_Msk | SYS_GPB_MFP1_PB5MFP_Msk | SYS_GPB_MFP1_PB4MFP_Msk);
    SYS->GPB_MFP1 |= (SYS_GPB_MFP1_PB6MFP_GPIO | SYS_GPB_MFP1_PB5MFP_GPIO | SYS_GPB_MFP1_PB4MFP_GPIO);

    return;
}

void M0A23OC_deinit_pb(void)
{
    SYS->GPB_MFP1 &= ~(SYS_GPB_MFP1_PB6MFP_Msk | SYS_GPB_MFP1_PB5MFP_Msk | SYS_GPB_MFP1_PB4MFP_Msk);

    return;
}

void M0A23OC_Pin_init_pc(void)
{
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC2MFP_Msk | SYS_GPC_MFP0_PC1MFP_Msk);
    SYS->GPC_MFP0 |= (SYS_GPC_MFP0_PC2MFP_GPIO | SYS_GPC_MFP0_PC1MFP_GPIO);
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC4MFP_Msk);
    SYS->GPC_MFP1 |= (SYS_GPC_MFP1_PC4MFP_GPIO);

    return;
}

void M0A23OC_deinit_pc(void)
{
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC2MFP_Msk | SYS_GPC_MFP0_PC1MFP_Msk);
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC4MFP_Msk);

    return;
}

void M0A23OC_Pin_init_pwm0(void)
{
    SYS->GPB_MFP1 &= ~(SYS_GPB_MFP1_PB7MFP_Msk);
    SYS->GPB_MFP1 |= (SYS_GPB_MFP1_PB7MFP_PWM0_CH0);

    return;
}

void M0A23OC_deinit_pwm0(void)
{
    SYS->GPB_MFP1 &= ~(SYS_GPB_MFP1_PB7MFP_Msk);

    return;
}

void M0A23OC_Pin_init_uart0(void)
{
    SYS->GPA_MFP1 &= ~(SYS_GPA_MFP1_PA5MFP_Msk | SYS_GPA_MFP1_PA4MFP_Msk);
    SYS->GPA_MFP1 |= (SYS_GPA_MFP1_PA5MFP_UART0_RXD | SYS_GPA_MFP1_PA4MFP_UART0_TXD);

    return;
}

void M0A23OC_deinit_uart0(void)
{
    SYS->GPA_MFP1 &= ~(SYS_GPA_MFP1_PA5MFP_Msk | SYS_GPA_MFP1_PA4MFP_Msk);

    return;
}

void M0A23OC_Pin_init_uart1(void)
{
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC3MFP_Msk);
    SYS->GPC_MFP0 |= (SYS_GPC_MFP0_PC3MFP_UART1_TXD);
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC5MFP_Msk);
    SYS->GPC_MFP1 |= (SYS_GPC_MFP1_PC5MFP_UART1_RXD);

    return;
}

void M0A23OC_deinit_uart1(void)
{
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC3MFP_Msk);
    SYS->GPC_MFP1 &= ~(SYS_GPC_MFP1_PC5MFP_Msk);

    return;
}

void M0A23OC_Pin_init_usci0(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA2MFP_Msk);
    SYS->GPA_MFP0 |= (SYS_GPA_MFP0_PA2MFP_USCI0_DAT0);
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC0MFP_Msk);
    SYS->GPC_MFP0 |= (SYS_GPC_MFP0_PC0MFP_USCI0_CLK);

    return;
}

void M0A23OC_deinit_usci0(void)
{
    SYS->GPA_MFP0 &= ~(SYS_GPA_MFP0_PA2MFP_Msk);
    SYS->GPC_MFP0 &= ~(SYS_GPC_MFP0_PC0MFP_Msk);

    return;
}

void M0A23OC_Pin_init(void)
{
    //SYS->GPA_MFP0 = 0x020B0202UL;
    //SYS->GPA_MFP1 = 0x00000908UL;
    //SYS->GPB_MFP1 = 0x05000000UL;
    //SYS->GPC_MFP0 = 0x1C00000AUL;
    //SYS->GPC_MFP1 = 0x13141D00UL;

    M0A23OC_Pin_init_can0();
    M0A23OC_Pin_init_ice();
    M0A23OC_Pin_init_nreset();
    M0A23OC_Pin_init_pb();
    M0A23OC_Pin_init_pc();
    M0A23OC_Pin_init_pwm0();
    M0A23OC_Pin_init_uart0();
    M0A23OC_Pin_init_uart1();
    M0A23OC_Pin_init_usci0();
    GPIO_SetMode(PB, BIT7, GPIO_MODE_QUASI);  // Gck -> D9
		GPIO_SetMode(PB, BIT6, GPIO_MODE_QUASI);	// Sck -> D13
    GPIO_SetMode(PB, BIT5, GPIO_MODE_QUASI);	// Do	-> D12
    GPIO_SetMode(PB, BIT4, GPIO_MODE_QUASI);	// Din	-> D11
		GPIO_SetMode(PC, BIT2, GPIO_MODE_QUASI);	// Latch -> D10


    return;
}

void M0A23OC_deinit(void)
{
    M0A23OC_deinit_can0();
    M0A23OC_deinit_ice();
    M0A23OC_deinit_nreset();
    M0A23OC_deinit_pb();
    M0A23OC_deinit_pc();
    M0A23OC_deinit_pwm0();
    M0A23OC_deinit_uart0();
    M0A23OC_deinit_uart1();
    M0A23OC_deinit_usci0();

    return;
}

/*** (C) COPYRIGHT 2013-2024 Nuvoton Technology Corp. ***/
